'37_in_1, moduli s "analognim" ulazima, PWM

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Cmd As Byte , Rgb As String * 1
Dim Rgb_s1 As Byte

Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions

Config Arduino_pin#2 = Input
Arduino_port#2 = 1

Config Timer0 = Pwm , Prescale = 64 , Compare_a_pwm = Clear_up , Compare_b_pwm = Clear_up
Compare0a = 0
Compare0b = 0
Config Timer2 = Pwm , Prescale = 64 , Compare_b_pwm = Clear_up
Compare2b = 0

Wait 1
Print "37_in_1 demo program 6"
Print "#2 = digital input"
Print "~3 = PWM (analog) output"
Print "~5 = PWM (analog) output"
Print "~6 = PWM (analog) output"
Print
Print "R0-R9"
Print "G0-G9"
Print "B0-B9"
Print "Y0-Y9"
Print

Do
  Debounce Arduino_pin#2 , 0 , S1_sub , Sub
  Cmd = Inkey()
  If Cmd <> 0 Then
    Gosub Cmd_sub
  End If
Loop

End

S1_sub:
  Incr Rgb_s1
  If Rgb_s1.0 = 0 Then
    Compare0a = 0
    Print "R=0 ";
  Else
    Compare0a = 128
    Print "R=128 ";
  End If
  If Rgb_s1.1 = 0 Then
    Compare0b = 0
    Print "G=0 ";
  Else
    Compare0b = 128
    Print "G=128 ";
  End If
  If Rgb_s1.2 = 0 Then
    Compare2b = 0
    Print "B=0 "
  Else
    Compare2b = 128
    Print "B=128 "
  End If
  Rgb = "?"
Return

Cmd_sub:
  If Chr(cmd) >= "0" And Chr(cmd) <= "9" Then
    Cmd = Cmd - &H30
    Cmd = Lookup(cmd , Int_table)
    If Rgb = "R" Or Rgb = "r" Then
      Compare0a = Cmd
      Print "R=" ; Cmd
    Elseif Rgb = "G" Or Rgb = "g" Then
      Compare0b = Cmd
      Print "G=" ; Cmd
    Elseif Rgb = "B" Or Rgb = "b" Then
      Compare2b = Cmd
      Print "B=" ; Cmd
    Elseif Rgb = "Y" Or Rgb = "y" Then
      Compare0a = Cmd
      Compare0b = Cmd
      Compare2b = Cmd
      Print "Y=" ; Cmd
    End If
  Else
    Rgb = Chr(cmd)
  End If
Return

Int_table:
Data 0 , 1 , 2 , 4 , 8 , 16 , 32 , 64 , 128 , 255